<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select v-model:value="model[field]" placeholder="请选择行业分类" :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions" @change="changeSuspect"></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select v-model:value="model[field]" show-search placeholder="请选择二级" allow-clear tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }" :tree-data="treeData"
          tree-node-filter-prop="label">
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleView" v-auth="'fxpg-dsl-jbxx'">查看基本信息</a-button>
        <a-button type="primary" @click="handleAdd" v-auth="'fxpg-dsl-sl'">受理</a-button>
      </template>
    </BasicTable>
    <AcceptanceModal @register="registerModal" @success="handleSuccess" />
  </div>
</template>

<script lang="ts" name="dkgl-fxpg-Acceptance" setup>
import { useRouter } from 'vue-router';
import { BasicTable } from '/@/components/Table';
import { useModal } from '/@/components/Modal';
import { useMessage } from '/@/hooks/web/useMessage';
import { useListPage } from '/@/hooks/system/useListPage';
import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
import { acceptanceList, getImportUrl, getExportUrl } from './api';
import AcceptanceModal from './modal/AcceptanceModal.vue'

const router = useRouter();
const { createMessage } = useMessage();
//注册model
const [registerModal, { openModal }] = useModal();
//注册table数据
const { tableContext } = useListPage({
  tableProps: {
    title: '风险评估-待受理',
    api: acceptanceList,
    columns,
    canResize: false,
    clickToRowSelect: true,
    showActionColumn: false,
    //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选
    rowKey: 'wrdkid',
    rowSelection: { type: 'radio' },
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      showAdvancedButton: false,
    },
  },
  exportConfig: {
    name: '风险评估-待受理',
    url: getExportUrl,
  },
  importConfig: {
    url: getImportUrl,
  },
});
const isSuspectOptions = useSuspectsData().data; // 行业分类
const useCategory = useCategoryData();
const treeData = useCategory.data; // 行业类别-数据
const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
const [registerTable, { reload }, { rowSelection, selectedRowKeys, selectedRows }] = tableContext;
// 查看基本信息
function handleView() {
  if (selectedRowKeys.value.length == 0) {
    createMessage.info('请选择需要处理的内容，每次只能选中一条');
    return
  }
  router.push(`/dkgl/fxpg/ViewDetail?wrdkid=${selectedRowKeys.value[0]}`)
}
/**
 * 受理
 */
function handleAdd() {
  if (selectedRowKeys.value.length == 0) {
    createMessage.info('请选择需要处理的内容，每次只能选中一条');
    return
  }

  openModal(true, {
    record: selectedRows.value[0],
    isUpdate: true,
    showFooter: true,
  });
}
function handleSuccess() {
  reload()
}

</script>
<style scoped></style>
